// Normalerweise wre _alloca(size_t) ein simples "sub esp,eax".
// Aber das Win32-Speicherlayout macht einen Strich durch die Rechnung und verlangt,
// dass der Stack Seite fr Seite abwrts belegt wird.
// Sonst kommt eine Schutzverletzung.
// Oder man legt per Linker-Schalter ein reichliches Commit fr den Stack fest. (Geht das??)
// Daher generiert der Compiler fr _alloca() sowie fr Funktionen mit mehr als 4 KByte
// lokale Variablen einen Aufruf dieser Funktion.
// Prinzipiell knnte diese eax/4 push-Befehle ausfhren 
// PE: eax = Zu reservierende Bytes
// PA: esp = Anfang des Speicherbereiches
// VR: eax

void _declspec(naked) _cdecl _alloca_probe() {_asm{
	add	eax,3
	and	al,~3		// Teilbarkeit durch 4 sicherstellen
	push	ecx
	 lea	ecx,[esp]+8	// ecx = Endadresse auf Stack
	 jmp	short testpg
onepg:	 sub	ecx,4096
	 sub	eax,4096
	 test	dword ptr [ecx],eax	// seitenweise Speicherlesezyklus anstoen
testpg:	 cmp	eax,4096
	 jae	short onepg
	 sub	ecx,eax			// ecx = Startadresse auf Stack
	 mov	eax,esp			// eax = Zeiger auf ursprngliches ecx
	 test	dword ptr [ecx],eax	// nochmal Speicherlesezyklus
	 mov	esp,ecx			// esp = Startadresse (Rckgabewert)
	mov	ecx,[eax]		// ecx restaurieren
	jmp	dword ptr[eax+4]	// Rcksprung zum Aufrufer
}}

void _declspec(naked) _cdecl _aullshr() {_asm{
	test	cl,32
	jc	l1
	shrd	eax,edx,cl
	shr	edx,cl
	ret
l1:	mov	eax,edx
	xor	edx,edx
	shr	eax,cl
	ret 
}}

void _declspec(naked) _cdecl _aulldiv() {_asm{
	push	ebx
	push	esi
	mov	eax,[esp+24]
	or	eax,eax
	jnz	short L1
	mov	ecx,[esp+20]
	mov	eax,[esp+16]
	xor	edx,edx
	div	ecx
	mov	ebx,eax
	mov	eax,[esp+12]
	div	ecx
	mov	edx,ebx
	jmp	short L2
L1:	mov	ecx,eax
	mov	ebx,[esp+20]
	mov	edx,[esp+16]
	mov	eax,[esp+12]
L3:	shr	ecx,1
	rcr	ebx,1
	shr	edx,1
	rcr	eax,1
	or	ecx,ecx
	jnz	short L3
	div	ebx
	mov	esi,eax
	mul	dword ptr [esp+24]
	mov	ecx,eax
	mov	eax,[esp+20]
	mul	esi
	add	edx,ecx
	jc	short L4
	cmp	edx,[esp+16]
	ja	short L4
	jb	short L5
	cmp	eax,[esp+12]
	jbe	short L5
L4:	dec	esi
L5:	xor	edx,edx
	mov	eax,esi
L2:	pop	esi
	pop	ebx
	ret	16
}}

void _declspec(naked) _cdecl _allmul() {_asm{
	mov	eax,[esp+8]
	mov	ecx,[esp+16]
	or	ecx,eax
	mov	ecx,[esp+12]
	jnz	short hard
	mov	eax,[esp+4]
	mul	ecx
	ret	16
hard:	push	ebx
	 mul	ecx
	 mov	ebx,eax
	 mov	eax,[esp+8]
	 mul	dword ptr [esp+20]
	 add	ebx,eax
	 mov	eax,[esp+8]
	 mul	ecx
	 add	edx,ebx
	pop	ebx
	ret	16
}}
